
#include <dxconfig.h>
#include <dx/dx.h>
#include "gl2ps.h"

#include "string.h"

/*
 * Error _dxfAsyncRender (Object, Camera, char *, char *);
 * Error _dxfAsyncDelete (char *);
 * Error DXSetSoftwareWindowActive(char *, int);
 */

#define MAX_PARAMS 21

Error m_PsVectorPrint(Object *in, Object *out)
{
	char *filename;
	char *where;
	FILE *fp;
	int state = GL2PS_OVERFLOW, buffsize = 0;
	GLint viewport[4];
	int format, sort, options, nbcol, i;
	char *string;
	
	ModuleInput  minput[MAX_PARAMS];
	ModuleOutput moutput[MAX_PARAMS];

	format = GL2PS_EPS;
//	sort = GL2PS_SIMPLE_SORT;
//	sort = GL2PS_BSP_SORT;
//	sort = GL2PS_NO_SORT;
//	options = GL2PS_SILENT | GL2PS_OCCLUSION_CULL | GL2PS_NO_PS3_SHADING;
//	options = GL2PS_SILENT | GL2PS_NO_PS3_SHADING;
	options = GL2PS_NONE;
	nbcol = 0;
	viewport[0] = 0;
	viewport[1] = 0;
	viewport[2] = 0;
	viewport[3] = 0;
	
	/*
	* Initialize all outputs to NULL
	*/
	
	if (!in[0]) {
	DXSetError(ERROR_BAD_PARAMETER, "missing object input");
	goto error;
	}
	if (!in[1]) {
	DXSetError(ERROR_BAD_PARAMETER, "missing camera input");
	goto error;
	}
	if (!in[2]) {
	DXSetError(ERROR_BAD_PARAMETER, "missing where input");
	goto error;
	}
	
	/* check filename 
	 */
	if (!in[3]) {
		DXSetError(ERROR_BAD_PARAMETER, "#10000", "file name");
		return ERROR;
	}

	/* unless multifile is enabled, the filename is required to be
	 *	a single a string.
	 */
	if (!DXExtractString(in[3], &filename))
	{
		DXSetError(ERROR_BAD_PARAMETER, "#10200", "file name");
		return ERROR;
	}
	fp = fopen(filename, "w");
	if(!fp){
		DXSetError(ERROR_DATA_INVALID, "Cennot open file", filename);
		return ERROR;
	}
	if (in[4]) {
		DXExtractString(in[4],&string);
		if (!strcmp(string,"ps")) {
			format = GL2PS_PS;
		} else if (!strcmp(string,"pdf")) {
			format = GL2PS_PDF;
		} else if (!strcmp(string,"tex")) {
			format = GL2PS_TEX;
		} else if (!strcmp(string,"eps")) {
			format = GL2PS_EPS;
		} else {
			DXSetError(ERROR_BAD_PARAMETER, 
				"Invalid output type \"%s\"\n", string);
			return ERROR;
		}
	} else {
		format = GL2PS_EPS;
	}
	if (in[5]) {
		DXExtractString(in[5],&string);
		if (!strcmp(string,"bsp")) {
			sort = GL2PS_BSP_SORT;
		} else if (!strcmp(string,"none")) {
			sort = GL2PS_NO_SORT;
		} else if (!strcmp(string,"simple")){
			sort = GL2PS_SIMPLE_SORT;
		} else {
			DXSetError(ERROR_BAD_PARAMETER, 
				"Invalid sort mode \"%s\"\n", string);
			return ERROR;
		}
	} else {
		sort = GL2PS_SIMPLE_SORT;
	}
	i = 6;
	while (in[i] && i<MAX_PARAMS) {
		DXExtractString(in[i],&string);
		if (!strcmp(string,"draw background")) {
			options = options | GL2PS_DRAW_BACKGROUND;
		} else if (!strcmp(string,"none")) {
			options = options | GL2PS_NO_SORT;
		} else if (!strcmp(string,"simple line offset")){
			options = options | GL2PS_SIMPLE_LINE_OFFSET;
		} else if (!strcmp(string,"no pixmap")){
			options = options | GL2PS_NO_PIXMAP;
		} else if (!strcmp(string,"best root")){
			options = options | GL2PS_BEST_ROOT;
		} else if (!strcmp(string,"landscape")){
			options = options | GL2PS_LANDSCAPE;
		} else if (!strcmp(string,"no ps3 shading")){
			options = options | GL2PS_NO_PS3_SHADING;
		} else if (!strcmp(string,"occlusion cull")){
			options = options | GL2PS_OCCLUSION_CULL;
		} else if (!strcmp(string,"compress ps")){
			options = options | GL2PS_COMPRESS;
		} else {
			DXSetError(ERROR_BAD_PARAMETER, 
				"Invalid option \"%s\"\n", string);
			return ERROR;
		}
		i++;
	}
	
	/* set hardware rendering */
	//DXGetStringAttribute(in[0], "rendering mode", &string);
	//DXMessage("L'attributo e' %s\n",string);
	DXSetStringAttribute(in[0], "rendering mode", "hardware");

	DXModSetObjectInput(&minput[0], "object", in[0]);
	DXModSetObjectInput(&minput[1], "camera", in[1]);
//	DXModSetStringInput(&minput[2], "where", "X");
	DXModSetObjectInput(&minput[2], "where", in[2]);
	DXModSetObjectOutput(&moutput[0], "where", in+2);
	

	//DXCallModule("Display",3,minput, 1, moutput);
	glGetIntegerv(GL_VIEWPORT, viewport);
	//DXCallModule("Display", 3, minput, 1, moutput);
	while(state == GL2PS_OVERFLOW){
		buffsize += 1024*1024;
		gl2psBeginPage(filename, "test", viewport, format, sort, 
					options,
					GL_RGBA, 0, NULL, nbcol, nbcol, nbcol, 
					buffsize, fp, filename);
		DXCallModule("Display", 3, minput, 1, moutput);
		state = gl2psEndPage();
	}
// 	DXDeleteAttribute(in[0], "rendering mode");
// 	DXCallModule("Display", 3, minput, 1, moutput);

	/* 
	* successful return 
	*/
	done:
	if ( fp ) fclose(fp);
	return OK;
	
	/* 
	* return on error 
	*/	

 error:
	/*
	* On error, any successfully-created outputs are deleted.
	*/
	if ( fp ) fclose(fp);
	return ERROR;
}




